# **smuHAT** <br/> _Hardware-on-top for synchronized measurements_

smuHAT is a hardware-on-top (HAT) for [RaspberryPi](https://www.raspberrypi.org/) [3 Model B](https://www.raspberrypi.com/products/raspberry-pi-3-model-b/) that allows to implement a low-cost and high-performance data acquisition system (DAQ) with the ability to synchronize the sampling time base to an external reference. Using a combination of fast logic gates, hardware interrupt detection capabilities offered by the secondary memory interface (SMI) and direct memory access (DMA) techniques, external signals (e.g. sync signal from GPS) can be used to phase lock the generation of a synchronous time base. This solution allows to achieve sub-microsecond latencies and very high data throughput on an OS based architecture without affecting CPU operation, thus providing high reliability for industrial applications without requiring a real-time (RT) environment.

## Schematic

[<img src="docs/sch_smu.png"  width="1100" height="761">](docs/sch_smu.png)

### Analog Front-End
[<img src="docs/sch_afe.png"  width="255" height="200">](docs/sch_afe.png)

The AFE is based on the [ADS8588s](https://www.ti.com/lit/ds/symlink/ads8588s.pdf) by Texas Instruments, an 8 channel 16-bit simultaneous sampling SAR ADC. The device features a complete analog front-end for each channel, including a programmable gain amplifier (PGA) with high input impedance of 1 MΩ and selectable range of ±5 V or ±10 V, input clamp, ADC input driver and 3rd order low-pass filter with BW = 24 kHz (±10 V) or BW = 14 kHz (±5 V). The device also features a low-drift, precision reference with a buffer to drive the ADC. The external array of 1st order LP differential filters with BW = 100 kHz are mainly used for impedance matching, but the frequency cut-off can be adjusted for applications with fixed sample rates lower than the ADC bandwidth. Additionally, the device features a flexible digital interface supporting serial, parallel, and parallel byte. The latter is used in the SMU v2 in combination with the secondary memory interface (SMI) to achieve the maximum throughput of 200 kSPS and requiring at the same time only 8 digital data pins rather than 16.

### Time synchronization
[<img src="docs/sch_gps.png"  width="605" height="200">](docs/sch_gps.png)

The SMU time synchronization is provided by the pulse-per-second (PPS) signal generated by a GPS module integrated on the board. The design supports both the [u-blox MAX](https://www.u-blox.com/en/product/max-m8-series) family of GPS modules and the low-cost module [SKG09BL](http://www.skylab.com.cn/uploadfile/Download/SkyLab_SKG09BL_V3.04_Datasheet.pdf) by Skylab, paired with any active antenna with Gain < 25 dB and SMA termination. The implemented design was tested with the u-blox [MAX-M8C](https://www.u-blox.com/sites/default/files/MAX-M8-FW3_DataSheet_%28UBX-15031506%29.pdf), which supports the concurrent reception of up to 3 GNSS (GPS, Galileo, GLONASS, BeiDou), paired with the Molex antenna [2134993000](https://www.molex.com/molex/products/part-detail/antennas/2134993000) suitable for multi-band reception. Alternatively, the setup can be improved using the MAX-M8Q that features a TXCO oscillator, or can be reduced in cost by selecting a module of the series MAX-8 with single GNSS reception, paired with a cheaper single-band antenna. However, the compatibility of the design with the module MAX-M8W, which features a built-in antenna supply and supervisor, was not tested. A high-speed DPDT multiplexer [NX3DV42](https://www.nxp.com/docs/en/data-sheet/NX3DV42.pdf) allows to switch pins IO14/15 between UART reception of GPS messages in NMEA protocol or data acquisition of the higher digital bits D6/D7 from the ADC.
<br/> [<img src="docs/smu_jumper_gps.png"  width="50" height="43">](docs/smu_jumper_gps.png)
<br/> (_**NOTE** After manufacturing the board will not work if the **PWR** solder jumper is not set to either Skylab or u-blox mode. If required, the optional **I2C** solder jumper can be closed to enable the communication with the u-blox via I2C._)

### Trigger generation
[<img src="docs/sch_trig.png"  width="915" height="200">](docs/sch_trig.png)

The ARM architecture of the Broadcom BCM2837 SoC used in the Raspberry Pi 3 does not support the set up of an interrupt vector table (IVT) when used with an operating system, but only in bare-metal. Therefore, it is not possible to register the memory address of an IRQ handler and interrupts have to be handled by the operating system, spawning a thread that polls the IRQ register. This mechanism is more than sufficient in most standard operations, providing in the user-space a typical latency of few hundred microseconds. When implemented in the kernel-space, latency can be further reduced to 4 us to few tenths of microseconds, a solution adopted in the SMU v1. To overcome this limitation, the SMU v2 combines direct memory access (DMA) and secondary memory interface (SMI) to provide synchronization latency in the order of few hundred nanoseconds. At the same time this approach provides also a solution for high-speed data transfers upon ADC data-ready interrupt. However, since the SMI data request interrupt is level-sensitive, the design features two monostable multivibrators with Schmitt trigger inputs [74LVC1G123](https://assets.nexperia.com/documents/data-sheet/74LVC1G123.pdf) by Nexperia, which convert the edge- in level-sensitive triggers with a proper duration. An OR digital port is then used to combine the two triggers in one digital signal used to pace the DMA; additionally, a third digital input allows to provide an external trigger if needed.

### System Calibration
[<img src="docs/sch_cal.png"  width="695" height="200">](docs/sch_cal.png)

The on-board system calibration is based on a environmental sensor [SHTC3](https://www.sensirion.com/fileadmin/user_upload/customers/sensirion/Dokumente/2_Humidity_Sensors/Datasheets/Sensirion_Humidity_Sensors_SHTC3_Datasheet.pdf) by Sensirion and on the [REF3440T](https://www.ti.com/lit/ds/symlink/ref3440.pdf) by Texas Instruments, a high precision voltage reference with low-drift (2.5 ppm/°C) and high-accuracy (0.05%). The sensor provides temperature and humidity readings useful to implement model-based compensation methods, for example accounting for the crystal oscillator (CXO) drift with the temperature. The voltage reference can be used instead to evaluate the gain drift of the AFE with temperature, but also to evaluate the signal attenuation introduced by custom impedance matching LP filters. The comparison is limited to the first channel, assuming that the observed variation affects similarly the other channels. If this feature is not required, it is also possible to avoid the installation of the voltage reference and of the two CPC2317N OptoMOS relays to reduce the overall costs.
<br/> [<img src="docs/smu_jumper_gps.png"  width="50" height="34">](docs/smu_jumper_cal.png)
<br/> (_**NOTE** If the voltage reference and the relays are not installed, the no-cal solder jumpers have to be closed._)

### Status Indicators
[<img src="docs/sch_status.png"  width="527" height="200">](docs/sch_status.png)

An array of three LED indicators allows to visually assess the status of the board. The rightmost indicator is based on a dual indicator, it is red if the board is powered and turns to green when the driver is enabled and the ADC leaves the standby. The middle yellow indicator shows that a data acquisition is in progess and the driver is notifying the application of new data available. The leftmost blue indicator shows that the PPS signal is correctly detected by blinking at the same pace.

## Printed Circuit Board

[<img src="docs/pcb_smu.png"  width="431" height="500">](docs/pcb_smu.png)

[<img src="docs/pcb_smu-F_Cu.png"  width="115" height="100">](docs/pcb_smu-F_Cu.png)
&nbsp;
[<img src="docs/pcb_smu-In1_Cu.png"  width="115" height="100">](docs/pcb_smu-In1_Cu.png)
&nbsp;
[<img src="docs/pcb_smu-In2_Cu.png"  width="115" height="100">](docs/pcb_smu-In2_Cu.png)
&nbsp;
[<img src="docs/pcb_smu-B_Cu.png"  width="115" height="100">](docs/pcb_smu-B_Cu.png)

## Media

[<img src="docs/smu_3d-top.png"  width="95" height="100">](docs/smu_3d-top.png)
&nbsp;
[<img src="docs/smu_3d-bottom.png"  width="96" height="100">](docs/smu_3d-bottom.png)


## Copyright
2017-2021, Carlo Guarnieri (ACS) <br/>
2021, Institute for Automation of Complex Power Systems, EONERC

## License

<a rel="license" href="http://creativecommons.org/licenses/by/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by/4.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by/4.0/">Creative Commons Attribution 4.0 International License</a>.

## Funding
<a rel="funding" href="https://hyperride.eu/"><img alt="HYPERRIDE" style="border-width:0" src="docs/hyperride_logo.png" height="63"/></a>&nbsp;
<a rel="funding" href="https://cordis.europa.eu/project/id/957788"><img alt="H2020" style="border-width:0" src="https://hyperride.eu/wp-content/uploads/2020/10/europa_flag_low.jpg" height="63"/></a><br />
This work was supported by <a rel="Hyperride" href="https://hyperride.eu/">HYbrid Provision of Energy based on Reliability and Resiliency via Integration of DC Equipment</a> (HYPERRIDE), a project funded by the European Union's Horizon 2020 research and innovation programme under <a rel="H2020" href="https://cordis.europa.eu/project/id/957788"> grant agreement No. 957788</a>.

## Contact

[![EONERC ACS Logo](docs/eonerc_logo.png)](http://www.acs.eonerc.rwth-aachen.de)

- [Carlo Guarnieri Calò Carducci, Ph.D.](mailto:carlo.guarnieri@ieee.org)

[Institute for Automation of Complex Power Systems (ACS)](http://www.acs.eonerc.rwth-aachen.de)  
[E.ON Energy Research Center (EONERC)](http://www.eonerc.rwth-aachen.de)  
[RWTH University Aachen, Germany](http://www.rwth-aachen.de)
